/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.lokalisierung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.lokalisierung.entity.Lokalisierung;
import de.ivu.elect.business.lokalisierung.entity.LokalisierungUK;

public abstract class AbstractLokalisierungDAO extends de.ivu.elect.jee.entity.AbstractDAO<Lokalisierung,
        de.ivu.elect.business.lokalisierung.entity.LokalisierungPK
    , LokalisierungUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractLokalisierungDAO.class);

  public AbstractLokalisierungDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.lokalisierung.entity.LokalisierungPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Lokalisierung findByPrimaryKey(
        de.ivu.elect.business.lokalisierung.entity.LokalisierungPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Lokalisierung findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Lokalisierung.class, id);
  }



     /**
      * Name: AllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Lokalisierung o<br>
      * SQL: <br>
      */
     public java.util.List<Lokalisierung> findByAll() {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  
                              return
                              getEntityManager().
                                createNamedQuery("LOKALISIERUNG.All")
                                                            .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Lokalisierung, findByAll - NonUniqueResultException, Parameter: "
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: SchluesselNoFlush<br>
      * Beschreibung: Automatisch generierter Finder<br>
      * EJBQL: SELECT OBJECT(o) FROM Lokalisierung o WHERE o.schluessel=?1<br>
      * SQL: <br>
      */
     public java.util.List<Lokalisierung> findBySchluessel( @javax.annotation.Nonnull java.lang.String schluessel) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  java.lang.String schluesselCheckedAndAttached =  schluessel ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("LOKALISIERUNG.Schluessel")
                              .setParameter(1, schluesselCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Lokalisierung, findBySchluessel - NonUniqueResultException, Parameter: "
           + ", schluessel:'"+schluessel+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findBySchluessel(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.lokalisierung.entity.LokalisierungUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.lokalisierung.entity.LokalisierungUK uk,
        de.ivu.elect.business.lokalisierung.entity.LokalisierungPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.lokalisierung.entity.Lokalisierung findByUK(de.ivu.elect.business.lokalisierung.entity.LokalisierungUK uk){

    try {
     return (de.ivu.elect.business.lokalisierung.entity.Lokalisierung) getEntityManager().createNamedQuery("LOKALISIERUNG.UK")
                  .setParameter(1, uk
                .getLocale ()

              )
             .setParameter(2, uk
                .getSchluessel ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Lokalisierung, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}